<script setup>
import { storeToRefs } from "pinia";
import { useRouter, useRoute } from "vue-router";
import BaseInput from "@/components/BaseInput.vue";
import BaseButton from "@/components/BaseButton.vue";
import { useInfoStore, MAX_LENGTH } from "@/stores/Info";
import { useSessionStore } from "@/stores/Session";

const router = useRouter();
const route = useRoute();
const infoStore = useInfoStore();
const sessionStore = useSessionStore();

const { joinSession } = sessionStore;

const { sessionId } = storeToRefs(sessionStore);
const { nickname, nameIsInvalid } = storeToRefs(infoStore);

const {
  query: { id },
} = route;

sessionId.value = id;

const attemptSessionJoin = () => {
  try {
    joinSession();
    router.push(`session/${sessionId.value}`);
  } catch (e) {
    console.error(e);
  }
};
</script>

<template>
  <div>
    <h5 class="card-header">Join a session</h5>
    <div class="card-body">
      <h5 class="card-title fw-bold">
        Join a session that has already been created.
      </h5>
      <div class="card-text row g-2">
        <div class="col-12">
          <BaseInput v-model="sessionId" label="Session ID" required />
        </div>
        <div class="col-12">
          <BaseInput
            v-model="nickname"
            label="Nickname"
            :max-length="MAX_LENGTH"
          />
        </div>
        <div class="col-12 d-grid d-md-flex justify-content-md-end">
          <BaseButton
            :disabled="!sessionId || nameIsInvalid"
            variant="info"
            @click="attemptSessionJoin"
          >
            Join
          </BaseButton>
        </div>
        <div class="card-text text-muted d-flex">
          Looking to create instead?&nbsp;<RouterLink to="/create"
            >Create</RouterLink
          >
        </div>
      </div>
    </div>
  </div>
</template>
